var natis = require('../natis')
var jdbc = require('./jdbc.js')
var validate = require('./validate.js')
var mlog = require('mqlog')
natis.config('mapper', './test/mapper/t01')
natis.config('jdbc', jdbc)
natis.config('validate', validate);
natis.init(function(err, db){


    // top(db, 'user', 9 ,0, 'top','','','',null )
    top(db, 'user', 9 ,1, 'up','','','',null )

})


function top(db, table, id, ordinal, type, ordinalField, catalog, catalogField, cb){
    ordinalField = ordinalField || 'ordinal'


    if(type == 'top' || type === 0){
        var param1 = {
            'table' : table,
            'ordinalField' : ordinalField,
            'catalog' : catalog,
            'catalogField' : catalogField
        }
        db.models.ordinal.findMin(param1).then(function(minOrdinal){
                var param2 = {
                    'table' : table,
                    'id' : id,
                    'ordinal' : minOrdinal - 1,
                    'ordinalField' : ordinalField
                }
                db.models.ordinal.updateOrdinal(param2, cb);
            })
    }

    else if(type == 'up' || type === 1){
        var param1 = {
            'table' : table,
            'ordinal' : ordinal,
            'ordinalField' : ordinalField,
            'catalog' : catalog,
            'catalogField' : catalogField
        }
        db.models.ordinal.findLower(param1).then(function(lowerOne){
                //更换顺序
                var param2 = {
                    'table' : table,
                    'id' : id,
                    'ordinal' : lowerOne[ordinalField],
                    'ordinalField' : ordinalField
                }
                db.models.ordinal.updateOrdinal(param2).then(function(){
                    //更换顺序
                    var param3 = {
                        'table' : table,
                        'id' : lowerOne['id'],
                        'ordinal' : ordinal,
                        'ordinalField' : ordinalField
                    }
                    db.models.ordinal.updateOrdinal(param3, cb);
                });
            })
    }

    else if(type == 'down' || type === -1){
        var param1 = {
            'table' : table,
            'ordinal' : ordinal,
            'ordinalField' : ordinalField,
            'catalog' : catalog,
            'catalogField' : catalogField
        }
        db.models.ordinal.findUpper(param1).then(function(upperOne){
                //更换顺序
                var param2 = {
                    'table' : table,
                    'id' : id,
                    'ordinal' : upperOne[ordinalField],
                    'ordinalField' : ordinalField
                }
                db.models.ordinal.updateOrdinal(param2).then(function(){
                    //更换顺序
                    var param3 = {
                        'table' : table,
                        'id' : upperOne['id'],
                        'ordinal' : ordinal,
                        'ordinalField' : ordinalField
                    }
                    db.models.ordinal.updateOrdinal(param3, cb);
                });
            })
    }
}
