var natis = require('../natis')
var jdbc = require('./jdbc.js')
var validate = require('./validate.js')
var mlog = require('mqlog')
natis.config('mapper', './test/mapper/t01')
natis.config('jdbc', jdbc)
natis.config('validate', validate);
natis.init(function(err, db){
    var data = [{'name':'33232'}]
    db.models.user.testInsertBatch({"data":data}, function(e, d){
        console.log(e)
        console.log(d)
    })

    return
    db.models.user.testInsert(function(e,data){
        console.log(e)
        console.log(data)

        var param = {
            id : data,
            name : '333'
        }

        db.models.user.testUpdate(param, function(e, d2){
            console.log(d2)
        })

        db.models.user.testQuery(function(e, d3){
            console.log(d3)
        })

    })



    return;
    db.models.user.findByDate(function(e, data){
        console.log(data);
    });

    return;

    return;
    //查询全部用户
    db.models.user.all(function(e, data){
        if(e){return console.log(e)}
        console.log(data.length);
    });

    //条件查询
    db.models.user.query({'name':'李'},function(e,data){
        if(e){return console.log(e)}
        console.log(data.length);
    })

    db.models.user.query({'name':'李','age':20},function(e,data){
        if(e){return console.log(e)}
        console.log(data.length);
    })

    db.models.user.query({'name':'李','minAge':20, 'maxAge':30},function(e,data){
        if(e){return console.log(e)}
        console.log(data.length);
    })

    //分页查询
    db.models.user.page({'name':'张','offset':0,'pageSize':10}, function(e, data){
        if(e){
            console.log(e);
            return;
        }
        console.log(data.length);
    });

    //查询数量
    db.models.user.count({'name':'张'}, function(e, total){
        if(e){
            console.log(e);
            return;
        }
        console.log(total);
    });

    //插入
    db.models.user.insert({'name':'hello','nickname':'nodejs','age':20,'birthday':'2018-02-01 10:22:11'},function(e,data){
        if(e){return console.log(e)}
        console.log(data);
    });

    //更新
    db.models.user.update({'id':2018,'name':'hello','nickname':'nodejs','age':20,'birthday':'2018-02-01 10:22:11'},function(e,data){
        if(e){return console.log(e)}
        console.log(data);
        db.models.user.find({'id':2018},function(e,data){
            console.log(data);
        });
    });

    //上下级
    db.models.user.findJob(function(e, data){
        if(e){return console.log(e)}
        mlog.info(data);
    });

    db.models.user.generateTree(function(e,data){
        if(e){return console.log(e)}
        mlog.info(data);
    });



})
